<?php

class W3_XooguGeotarget
{
	protected $sDefaultCountry;
	protected $aCountryList;
	
	
	public function run()
	{
		$this->aCountries = w3tc_get_extension_config('xoogu-geotarget-w3tc', 'countries', null, array());
        $this->sDefaultCountry = w3tc_get_extension_config('xoogu-geotarget-w3tc', 'default-country', null, 'US');
		w3tc_add_action('w3tc_pgcache_cache_key', array($this, 'modifyKey'));
	}
	
	public function filterCountryCode($sCountryCode)
	{
		return $_SERVER['GEOIP_COUNTRY_CODE'] = in_array($sCountryCode, $this->aCountries) ? $sCountryCode : $this->sDefaultCountry;
	}
	
	public function modifyKey($sKey)
	{
		$iPos = strrpos($sKey, '.');
		$sExt = substr($sKey, $iPos);
		$sKey = substr($sKey, 0, $iPos);
		if ( $sExt === '.html' || $sExt === '.html_gzip' ) {
			if (isset($_SERVER['GEOIP_COUNTRY_CODE'])){
				$sCountryCode = $_SERVER['GEOIP_COUNTRY_CODE'];
			} else if (function_exists('geoip_country_code_by_name')) {
				$sIP = !empty($_SERVER["HTTP_X_FORWARDED_FOR"]) ? $_SERVER["HTTP_X_FORWARDED_FOR"] : $_SERVER['REMOTE_ADDR'];
				$sCountryCode = geoip_country_code_by_name($sIP);
			}
			$sKey .= '_'.$this->filterCountryCode($sCountryCode);
		}
		$sKey = $sKey.$sExt;
		return $sKey;
	}
}

$ext = new W3_XooguGeotarget();
$ext->run();

